property pShuttleObj, pDisplayObj, pExpState, pExpCounter, pShuttleSprite, pReserveShuttles, pMissleSprite, pMaxMissles, pCometSprite, pMaxComets, pCometCount, pLevel, pPromptSprite, pSecondsSprite, pLevelSprite
global gMissleList, gCometList, gHiScoreObj, gPauseState

on new me
  set thisCursor to the memberNum of member "crosshair"
  set the cursor of sprite 0 to [thisCursor]
  set pShuttleSprite to 23
  set pExpState to 0
  set pReserveShuttles to 2
  set pMissleSprite to 3
  set pMaxMissles to 6
  set pCometSprite to 13
  set pMaxComets to 8
  set pCometCount to pMaxComets
  set pLevel to 1
  set pPromptSprite to 43
  set pLevelSprite to 44
  set pSecondsSprite to 46
  puppetSprite(pPromptSprite, 1)
  set temp to pLevelSprite
  repeat with x = 1 to 2
    puppetSprite(temp, 1)
    set temp to temp + 1
  end repeat
  set the member of sprite pPromptSprite to "Get Ready"
  set the member of sprite pSecondsSprite to "3"
  updateStage()
  set score to 0
  set meterSprite to 26
  mInitializeLists(me)
  set pShuttleObj to new(script "aShuttleObj", pShuttleSprite)
  set pDisplayObj to new(script "aDisplayObj", score, meterSprite, pReserveShuttles)
  startTimer()
  return me
end

on mInitializeLists me
  set gMissleList to []
  repeat with x = 1 to pMaxMissles
    addAt(gMissleList, x, 0)
  end repeat
  set gCometList to []
  repeat with x = 1 to pMaxComets
    addAt(gCometList, x, 0)
  end repeat
  mCreateComets(me)
end

on mCreateComets me
  repeat with x = 1 to count(gCometList)
    set slot to 0
    repeat with x = 1 to count(gCometList)
      if getAt(gCometList, x) = 0 then
        set slot to 1
        exit repeat
      end if
    end repeat
    if slot then
      deleteAt(gCometList, x)
      addAt(gCometList, x, new(script "aCometObj", x, pLevel))
    end if
  end repeat
end

on mPlayGame me
  if pExpState = 1 then
    mExplodeShuttle(me)
  else
    if pCometCount > 0 then
      if the timer > 1800 then
        startTimer()
        mAddMeter(pDisplayObj)
      end if
      mMoveShuttle(pShuttleObj)
      if the mouseDown then
        set theClickV to the mouseV
        mLaunchMissle(me, theClickV)
      end if
      repeat with x = 1 to count(gMissleList)
        set thisValue to getAt(gMissleList, x)
        if not (thisValue = 0) then
          mMoveMissle(thisValue)
        end if
      end repeat
      repeat with x = 1 to count(gCometList)
        set thisValue to getAt(gCometList, x)
        if not (thisValue = 0) then
          mMoveComet(thisValue)
        end if
      end repeat
      mDetectCollision(me)
    else
      mNextLevel(me)
    end if
  end if
end

on mLaunchMissle me, Vloc
  set slot to 0
  repeat with x = 1 to count(gMissleList)
    if getAt(gMissleList, x) = 0 then
      set slot to 1
      exit repeat
    end if
  end repeat
  if slot then
    deleteAt(gMissleList, x)
    addAt(gMissleList, x, new(script "aMissleObj", x, Vloc, pShuttleSprite))
    puppetSound(1, "Shoot")
    updateStage()
  end if
end

on mDetectCollision me
  repeat with x = 1 to count(gCometList)
    set thisCometObj to getAt(gCometList, x)
    if thisCometObj = 0 then
      next repeat
    end if
    set cometSprite to mGetSprite(thisCometObj)
    set missleSprite to pMissleSprite
    repeat with missleCount = 1 to count(gMissleList)
      set thisMissle to getAt(gMissleList, missleCount)
      if thisMissle <> 0 then
        set expValue to mGetExpState(thisMissle)
        case expValue of
          0:
            nothing()
          1:
            if sprite missleSprite intersects sprite(cometSprite) then
              mExplodeComet(thisCometObj)
            end if
        end case
      end if
      set missleSprite to missleSprite + 1
    end repeat
    if sprite cometSprite intersects sprite(pShuttleSprite) then
      puppetSound(2, "ShuttleHit")
      set pExpState to 1
      set pExpCounter to 1
      puppetSprite(cometSprite, 0)
      deleteAt(gCometList, x)
      addAt(gCometList, x, 0)
      exit repeat
    end if
    if the locV of sprite cometSprite > 460 then
      set thisCometState to mGetExplodeState(thisCometObj)
      case thisCometState of
        0:
          puppetSound(3, "ShuttleHit")
          mExplodeComet(thisCometObj)
          set endValue to mDeleteMeter(pDisplayObj)
          if endValue then
            EndGame()
            exit repeat
          end if
        otherwise:
          set thisCometState to mGetExplodeState(thisCometObj)
          case thisCometState of
            0:
              puppetSprite(cometSprite, 0)
              deleteAt(gCometList, x)
              addAt(gCometList, x, new(script "aCometObj", x, pLevel))
            1:
              mExplodeComet(thisCometObj)
          end case
      end case
    end if
  end repeat
end

on mEndPuppets me
  puppetSprite(pShuttleSprite, 0)
  set missleSprite to pMissleSprite
  repeat with x = 1 to count(gMissleList)
    puppetSprite(missleSprite, 0)
    set missleSprite to missleSprite + 1
  end repeat
  set cometSprite to pCometSprite
  repeat with x = 1 to count(gCometList)
    puppetSprite(cometSprite, 0)
    set cometSprite to cometSprite + 1
  end repeat
  updateStage()
end

on mEndGame me
  cursor(200)
  updateStage()
  puppetSprite(pShuttleSprite, 0)
  set meterSprite to mGetSprite(pDisplayObj)
  puppetSprite(meterSprite, 0)
  repeat with x = 1 to count(gMissleList)
    set thisMissleObj to getAt(gMissleList, x)
    if thisMissleObj <> 0 then
      set missleSprite to mGetSprite(thisMissleObj)
      puppetSprite(missleSprite, 0)
    end if
  end repeat
  repeat with x = 1 to count(gCometList)
    set thisCometObj to getAt(gCometList, x)
    if thisCometObj <> 0 then
      set cometSprite to mGetSprite(thisCometObj)
      puppetSprite(cometSprite, 0)
    end if
  end repeat
  mHidePuppets(pDisplayObj)
  set temp to pLevelSprite
  repeat with x = 1 to 2
    puppetSprite(temp, 0)
    set temp to temp + 1
  end repeat
  set theScore to mGetScore(pDisplayObj)
  maddToList(gHiScoreObj, theScore)
  go("End Game")
end

on mShowPrompts me
  set the visible of sprite pPromptSprite to 1
  set the visible of sprite pSecondsSprite to 1
  set temp to pLevelSprite
  repeat with x = 1 to 2
    set the visible of sprite temp to 1
    set temp to temp + 1
  end repeat
  updateStage()
  startTimer()
  repeat while the timer < 180
    case the timer of
      60:
        set the member of sprite pSecondsSprite to "2"
        updateStage()
      120:
        set the member of sprite pSecondsSprite to "1"
        updateStage()
      otherwise:
        nothing()
    end case
  end repeat
  mHidePrompts(me)
end

on mHidePrompts me
  set the visible of sprite pPromptSprite to 0
  set the visible of sprite pSecondsSprite to 0
  set temp to pLevelSprite
  repeat with x = 1 to 2
    set the visible of sprite temp to 0
    set temp to temp + 1
  end repeat
  updateStage()
  set the member of sprite pSecondsSprite to "3"
  set tempLevel to string(pLevel + 1)
  set loopCount to the number of chars in tempLevel
  set temp to pLevelSprite
  repeat with levelSprite = 1 to 2
    set thisDigit to char loopCount of tempLevel
    set the member of sprite temp to thisDigit
    set loopCount to loopCount - 1
    set temp to temp + 1
    if loopCount = 0 then
      exit repeat
    end if
  end repeat
end

on mNewWave me
  mEndPuppets(me)
  updateStage()
  mInitializeLists(me)
  puppetSprite(pShuttleSprite, 1)
  go("New Game")
end

on mNextLevel me
  mEndPuppets(me)
  updateStage()
  mInitializeLists(me)
  puppetSprite(pShuttleSprite, 1)
  set pLevel to pLevel + 1
  set pCometCount to pMaxComets
  go("New Game")
end

on mDecreaseComets me
  set temp to pMaxComets
  repeat with x = 1 to count(gCometList)
    if getAt(gCometList, x) = 0 then
      set temp to temp - 1
    end if
  end repeat
  set pCometCount to temp
  mAddScore(pDisplayObj)
end

on mExplodeShuttle me
  if pExpCounter > 9 then
    set endValue to mRemoveShuttle(pDisplayObj)
    if endValue then
      repeat while soundBusy(2)
        nothing()
      end repeat
      puppetSound("Wave Over")
      updateStage()
      repeat while soundBusy(1)
        nothing()
      end repeat
      EndGame()
    else
      set pExpCounter to 0
      set pExpState to 0
      puppetSound("Wave Over")
      updateStage()
      repeat while soundBusy(1)
        nothing()
      end repeat
      mNewWave()
    end if
  else
    set memberName to "Exp" & pExpCounter
    set the member of sprite pShuttleSprite to memberName
    updateStage()
    set pExpCounter to pExpCounter + 1
  end if
end

on mReturnToMain me
  cursor(0)
  updateStage()
  puppetSprite(pShuttleSprite, 0)
  set meterSprite to mGetSprite(pDisplayObj)
  puppetSprite(meterSprite, 0)
  repeat with x = 1 to count(gMissleList)
    set thisMissleObj to getAt(gMissleList, x)
    if thisMissleObj <> 0 then
      set missleSprite to mGetSprite(thisMissleObj)
      puppetSprite(missleSprite, 0)
    end if
  end repeat
  repeat with x = 1 to count(gCometList)
    set thisCometObj to getAt(gCometList, x)
    if thisCometObj <> 0 then
      set cometSprite to mGetSprite(thisCometObj)
      puppetSprite(cometSprite, 0)
    end if
  end repeat
  set temp to pLevelSprite
  repeat with x = 1 to 2
    puppetSprite(temp, 0)
    set temp to temp + 1
  end repeat
  mHidePuppets(pDisplayObj)
  go("Menu")
end

on mTogglePause me
  case gPauseState of
    0:
      set the visible of sprite pPromptSprite to 0
      set the member of sprite pPromptSprite to "Get Ready"
    1:
      set the member of sprite pPromptSprite to "Pause"
      set the visible of sprite pPromptSprite to 1
  end case
  updateStage()
end
